<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditTourBusinessBannerRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="banner名称" prop="TourBusinessBanner.bannerName">
              <el-input
                class="input-item"
                v-model="formData.TourBusinessBanner.bannerName"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="业务名称" prop="TourBusinessBanner.businessType">
              <el-select
                class="input-item"
                v-model="formData.TourBusinessBanner.businessType"
                placeholder=""
                :clearable="true"
                :filterable="true"
                @visible-change="businessTypeWidget.onVisibleChange"
              >
                <el-option
                  v-for="item in businessTypeWidgetDropdownList"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="是否启用" prop="TourBusinessBanner.enable">
              <el-select
                class="input-item"
                v-model="formData.TourBusinessBanner.enable"
                placeholder=""
                :clearable="true"
                :filterable="true"
                @visible-change="enableWidget.onVisibleChange"
              >
                <el-option
                  v-for="item in enableWidgetDropdownList"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="是否主banner" prop="TourBusinessBanner.mainBanner">
              <el-select
                class="input-item"
                v-model="formData.TourBusinessBanner.mainBanner"
                placeholder=""
                :clearable="true"
                :filterable="true"
                @visible-change="mainBannerWidget.onVisibleChange"
              >
                <el-option
                  v-for="item in mainBannerWidgetDropdownList"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="图片URL" prop="TourBusinessBanner.imgUrl">
              <custom-upload
                v-model="imgUrlWidgetFileList"
                name="uploadFile"
                :size="layoutStore.defaultFormItemSize"
                type="expand"
                :headers="getUploadHeaders"
                :action="getUploadActionUrl('/admin/app/tourBusinessBanner/upload')"
                :data="{fieldName: 'imgUrl', asImage: true}"
                :limit="imgUrlWidgetMaxCount"
                @change="onImgUrlChange"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="跳转链接" prop="TourBusinessBanner.bannerUrl">
              <el-input
                class="input-item"
                v-model="formData.TourBusinessBanner.bannerUrl"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="banner排序" prop="TourBusinessBanner.showOrder">
              <el-input-number
                class="input-item"
                v-model="formData.TourBusinessBanner.showOrder"
                placeholder=""
                :clearable="true"
                :step="1"
                :controls="true"
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSubmitTourBusinessBannerClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditTourBusinessBanner',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourBusinessBannerData } from '@/api/generated/tourBusinessBannerController';
import { TourBusinessBannerController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditTourBusinessBannerRef = ref();
// 表单数据定义
type FormEditTourBusinessBannerData = {
  TourBusinessBanner: TourBusinessBannerData;
};
// 表单数据
const formData = reactive<FormEditTourBusinessBannerData>({
  TourBusinessBanner: {
    // 主键
    id: undefined,
    // banner名称
    bannerName: undefined,
    // 业务名称
    businessType: undefined,
    // 是否启用，0否，1是
    enable: undefined,
    // 是否主banner，0否，1是
    mainBanner: undefined,
    // 图片URL
    imgUrl: undefined,
    // 跳转链接
    bannerUrl: undefined,
    // banner排序
    showOrder: undefined,
    // 删除标记(1: 正常 -1: 已删除)
    dataState: undefined,
    // 创建人
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 修改人
    updateUserId: undefined,
    // 修改时间
    updateTime: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'TourBusinessBanner.imgUrl': [
  ],
  'TourBusinessBanner.bannerUrl': [
  ],
  'TourBusinessBanner.enable': [
  ],
  'TourBusinessBanner.mainBanner': [
  ],
  'TourBusinessBanner.bannerName': [
  ],
  'TourBusinessBanner.businessType': [
  ],
  'TourBusinessBanner.showOrder': [
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadTourBusinessBannerData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.TourBusinessBanner = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    TourBusinessBannerController.view(params).then(res => {
      formData.TourBusinessBanner = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 业务名称下拉数据获取函数
 */
const loadBusinessTypeDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    DictionaryController.dictGlobalDict({ dictCode: 'TourBusinessType', itemIdType: 'Integer' }).then(res => {
      resolve({
        dataList: res.getList(),
      });
    }).catch(e => {
      reject(e);
    });
  });
};
// 业务名称配置参数
const businessTypeOptions: DropdownOptions<DictData> = {
  loadData: loadBusinessTypeDropdownList,
  isTree: false,
};
// 业务名称下拉组件
const businessTypeWidget = useDropdown(businessTypeOptions);
const { dropdownList: businessTypeWidgetDropdownList } = businessTypeWidget
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.IsTrue.getList(),
  });
};
// 是否启用配置参数
const enableOptions: DropdownOptions<DictData> = {
  loadData: loadEnableDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableWidget = useDropdown(enableOptions);
const { dropdownList: enableWidgetDropdownList } = enableWidget
/**
 * 是否主banner下拉数据获取函数
 */
const loadMainBannerDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.IsTrue.getList(),
  });
};
// 是否主banner配置参数
const mainBannerOptions: DropdownOptions<DictData> = {
  loadData: loadMainBannerDropdownList,
  isTree: false,
};
// 是否主banner下拉组件
const mainBannerWidget = useDropdown(mainBannerOptions);
const { dropdownList: mainBannerWidgetDropdownList } = mainBannerWidget
/**
 * 图片URL上传文件改变
 */
const onImgUrlChange = val => {
  formData.TourBusinessBanner.imgUrl = fileListToJson(val);
};
// 图片URL上传文件组件
const imgUrlWidget = useUploadWidget(1);
const { fileList: imgUrlWidgetFileList, maxCount: imgUrlWidgetMaxCount } = imgUrlWidget;
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditTourBusinessBanner = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditTourBusinessBanner = () => {
  refreshFormEditTourBusinessBanner();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditTourBusinessBanner();
};
/**
 * 保存
 */
const onSubmitTourBusinessBannerClick = () => {
  formEditTourBusinessBannerRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.TourBusinessBanner
      };
    retFormData.businessTypeDictMap = findItemFromList(businessTypeWidgetDropdownList.value, retFormData.businessType, 'id');
    retFormData.enableDictMap = findItemFromList(enableWidgetDropdownList.value, retFormData.enable, 'id');
    retFormData.mainBannerDictMap = findItemFromList(mainBannerWidgetDropdownList.value, retFormData.mainBanner, 'id');
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      tourBusinessBannerDto: {
        id: formData.TourBusinessBanner.id,
        bannerName: formData.TourBusinessBanner.bannerName,
        businessType: formData.TourBusinessBanner.businessType,
        enable: formData.TourBusinessBanner.enable,
        mainBanner: formData.TourBusinessBanner.mainBanner,
        imgUrl: formData.TourBusinessBanner.imgUrl,
        bannerUrl: formData.TourBusinessBanner.bannerUrl,
        showOrder: formData.TourBusinessBanner.showOrder,
        dataState: formData.TourBusinessBanner.dataState,
        createUserId: formData.TourBusinessBanner.createUserId,
        createTime: formData.TourBusinessBanner.createTime,
        updateUserId: formData.TourBusinessBanner.updateUserId,
        updateTime: formData.TourBusinessBanner.updateTime,
      }
    };

    let httpCall = isEdit.value ? TourBusinessBannerController.update : TourBusinessBannerController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadTourBusinessBannerData().then(res => {
    businessTypeWidget.onVisibleChange(true).catch(e => {console.error(e)});
    enableWidget.onVisibleChange(true).catch(e => {console.error(e)});
    mainBannerWidget.onVisibleChange(true).catch(e => {console.error(e)});
    let imgUrlDownloadParams = {
      id: formData.TourBusinessBanner.id,
      fieldName: 'imgUrl',
      asImage: true
    };
    imgUrlWidgetFileList.value = parseUploadData(formData.TourBusinessBanner.imgUrl, imgUrlDownloadParams);
    if (isEdit.value) refreshFormEditTourBusinessBanner();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
